package me.unurled.sacredrealms.sr.components.item;

import java.util.HashMap;
import me.unurled.sacredrealms.sr.managers.Manager;
import org.bukkit.NamespacedKey;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataType;

@SuppressWarnings("EmptyMethod")
public class ItemManager extends Manager {
  public static final NamespacedKey ID = new NamespacedKey("sr", "id");

  private final HashMap<String, Item> items;

  public ItemManager() {
    super();
    items = new HashMap<>();
  }

  /** Register all the items */
  private void registerItems() {}

  /** Load the manager */
  @Override
  public void load() {
    super.load();
    registerItems();
  }

  public void addItem(Item item) {
    items.put(item.getID(), item);
  }

  public Item getItem(String id) {
    return items.get(id);
  }

  public Item getItem(ItemStack item) {
    if (item == null) return null;
    if (item.getItemMeta() == null) return null;
    if (item.getItemMeta().getPersistentDataContainer().has(ID, PersistentDataType.STRING)) {
      return getItem(
          item.getItemMeta().getPersistentDataContainer().get(ID, PersistentDataType.STRING));
    }
    return null;
  }

  public void removeItem(String id) {
    items.remove(id);
  }

  public boolean isItem(String id) {
    return items.containsKey(id);
  }
}
